Skip to main content

Documentation Index

Fetch the complete documentation index at: https://launchdarkly-preview.mintlify.app/llms.txt

Use this file to discover all available pages before exploring further.

Overview

This topic explains how various SDKs monitor the connection to LaunchDarkly to determine the most recent flag values.

Monitor the connection to Launch

Darkly Some SDKs expose some of their internal statuses through the Connection Status API to allow your application to monitor the SDK’s status. This is provided primarily as a mechanism for the application to determine how recently the internal flag cache has been updated with the most recent values, as well as diagnosing potential reasons for the flag cache to be out of date.

Client-side SDKs

This feature is available in the following client-side SDKs:

.NET (client-side)

This feature is available in the client-side .NET SDK’s versions 2.0.0 and later.
The client-side .NET SDK defines “data source status” as the status of the SDK’s communication with LaunchDarkly to get feature flag data. If the streaming connection to LaunchDarkly is interrupted, or, in polling mode, if a polling request fails, the SDK might not be able to receive flag updates. The data source status will indicate this, providing an overall state such as “valid” or “interrupted” and information about the last error that occurred, if any.To check the data source status:
      var dataSourceStatus = client.DataSourceStatusProvider.Status;
Alternatively, you can register an event handler that will receive a new status value whenever the status changes.Here is an example:
      client.DataSourceStatusProvider.StatusChanged +=
          (sender, status) => {
              Console.WriteLine("new status is: {0}", status);
          };
To learn more, read IDataSourceStatusProvider.

Android

This feature is available in the Android SDK’s versions 2.8.0 and later.
The Android SDK exposes some of its internal status through APIs to let your application monitor it. This allows the application to determine how recently the internal flag cache has been updated with the most recent values, as well as diagnosing potential reasons for the flag cache to be out of date.The SDK has seven connectivity states dependent on its configuration, application foreground state, network connectivity, and calls explicitly setting the client offline or online.This table describes the states:| Connection mode
Description
| --- | | STREAMING | The SDK is either connected to the flag stream, or is actively attempting to acquire a connection. | | POLLING | The SDK is in foreground polling mode because it was configured with streaming disabled. | | BACKGROUND_POLLING | The SDK has detected the application is in the background and has transitioned to battery-saving background polling. | | BACKGROUND_DISABLED | The SDK was configured with background polling disabled. The SDK has detected the application is in the background and is not attempting to update the flag cache. | | OFFLINE | The SDK has detected that the mobile device does not have an active network connection. It has ceased flag update attempts until the network status changes. | | SET_OFFLINE | The SDK has been explicitly set offline, either in the initial configuration, by setOffline(), or as a result of failed authentication to LaunchDarkly. The SDK will stay offline unless setOnline() is called. | | SHUTDOWN | The shutdown state indicates the SDK has been permanently shutdown as a result of a call to close() . |The SDK also internally stores a timestamp of the most recent successful and failed connections to LaunchDarkly, as well as information related to the most recent failed connection. The LDClient method getConnectionInformation() returns a structure allowing retrieval of these fields.
      LDClient client = LDClient.get();
      ConnectionInformation connectionInfo = client.getConnectionInformation();
      // One of the seven modes described above
      ConnectionInformation.ConnectionMode connectionMode =
        connectionInfo.getConnectionMode();
      // Most recent successful flag cache update in millis from the epoch
      // Or null if flags have never been retrieved
      Long lastSuccess = connectionInfo.getLastSuccessfulConnection();
      // Most recent unsuccessful flag cache update attempt in millis from the epoch
      // Or null if flag update has never been attempted
      Long lastError = connectionInfo.getLastFailedConnection();
      // Most recent failure or null
      LDFailure ldFailure = connectionInfo.getLastFailure();
LDFailure is a LaunchDarklyException with an associated FailureType. It may include a .cause(), which is propagated from an underlying exception associated with the update’s failure. The cause itself should be considered unstable because it is dependent on internal implementation, though the mechanism to retrieve it will be maintained.The failure types are summarized below:| FailureType
Description
| --- | | INVALID_RESPONSE_BODY | A response body received either through polling or streaming was unable to be parsed. | | NETWORK_FAILURE | A network request for polling, or the EventSource stream reported a failure. | | UNEXPECTED_STREAM_ELEMENT_TYPE | An event was received through the stream with an unknown event key. This could indicate a newer SDK is available if new event kinds have become available through the flag stream since the SDK’s release. | | UNEXPECTED_RESPONSE_CODE | This indicates the LDFailure is an instance of LDInvalidResponseCodeFailure. Continue reading below for more details. | | UNKNOWN_ERROR | Some other issue occurred. |If matching on the FailureType, use a default case to handle any future cases provided. The UNEXPECTED_RESPONSE_CODE case indicates that you can cast the LDFailure to a LDInvalidResponseCodeFailure for more information. This more specific failure includes a response code and whether the failure is considered retryable.Here is an example:
      LDClient client = LDClient.get();
      ConnectionInformation connectionInfo = client.getConnectionInformation();
      LDFailure ldFailure = connectionInfo.getLastFailure();
      if (ldFailure != null) {
          Timber.d("Received failure with message %s", ldFailure.getMessage());
          // Retrieve the failure type
          LDFailure.FailureType failureType = ldFailure.getFailureType();
          switch (failureType) {
              case INVALID_RESPONSE_BODY:
                  Timber.d("Received invalid response body");
                  break;
              case NETWORK_FAILURE:
                  Timber.d("Network failure, may have bad connection");
                  break;
              case UNEXPECTED_STREAM_ELEMENT_TYPE:
                  Timber.d("Unexpected stream element, may require update");
                  break;
              case UNEXPECTED_RESPONSE_CODE:
                  LDInvalidResponseCodeFailure responseCodeFailure =
                      (LDInvalidResponseCodeFailure) ldFailure;
                  int responseCode = responseCodeFailure.getResponseCode();
                  if (responseCodeFailure.isRetryable()) {
                      Timber.d("Received invalid response code %d", responseCode);
                  } else {
                      Timber.d("Received invalid response code %d, giving up", responseCode);
                  }
                  break;
              case UNKNOWN_ERROR:
              default:
                  Timber.d("Unknown error");
                  break;
          }

          Throwable cause = ldFailure.getCause();
          if (cause != null) {
              // Do something with underlying cause
          }
      }
A callback-based interface is also provided to allow notifying the application when the ConnectionMode changes, as well as whenever the LDFailure in ConnectionStatus changes. The application must provide a class instance implementing LDStatusListener to the SDK client instance method registerStatusListener to register the listeners with the SDK.
The SDK maintains only a weak reference to the registered LDStatusListener, so the application maintains a reference for as long as the application desires the listener to be available. This helps prevent creating a long-term reference to an Activity by creating a static internal class instance for use as a listener. By using a weak reference to the listener, the Activity can still be garbage collected normally, even if it maintains a registered LDStatusListener. We recommend unregistering the listener when it’s finished.
Here is a brief example:
      class MainActivity extends Activity {
          private LDClient client;
          private LDStatusListener ldStatusListener;

          @Override
          protected void onCreate(Bundle savedInstanceState) {
              super.onCreate(savedInstanceState);
              setContentView(R.layout.activity_main);

              ldStatusListener = new LDStatusListener() {
                  @Override
                  public void onConnectionModeChanged(ConnectionInformation connectionInfo) {
                      // handle new connection info
                  }

                  @Override
                  public void onInternalFailure(LDFailure ldFailure) {
                      // handle failure
                  }
              };

              client = LDClient.get();
              client.registerStatusListener(ldStatusListener);
          }

          @Override
          protected void onDestroy() {
              super.onDestroy();
              client.unregisterStatusListener(ldStatusListener);
          }
      }

C++ (client-side)

The C++ (client-side) SDK exposes some of its internal status to let your application monitor it.The SDK has several data source states dependent on its configuration, network connectivity, and calls explicitly setting the client offline or online.This table describes the states:| Data source state
Description
| --- | | kInitializing| The initial state of the data source when the SDK is being initialized. | | kValid| The data source is currently operational and has not had any problems since the last time it received data. | | kInterrupted| The data source encountered an error that it will attempt to recover from. | | kSetOffline| The application has told the SDK to stay offline. | | kShutdown| The data source has been permanently shut down. This could be because it encountered an unrecoverable error, or because the SDK client was explicitly shut down. |The SDK stores a timestamp of when the data source state most recently changed. It also stores information about the last error that the data source encountered, if any.This table describes the possible errors:| LastError value
Description
| --- | | kUnknown| An unexpected error, such as an uncaught exception. | | kNetworkError| An I/O error, such as a dropped connection. | | kErrorResponse| The LaunchDarkly service returned an HTTP response with an error status. | | kInvalidData| The SDK received malformed data from the LaunchDarkly service. | | kStoreError| The data source itself is working, but when it tried to put an update into the data store, the data store failed. The SDK may not have the latest data. |Here’s how to monitor the data source state:
      client.DataSourceStatus().OnDataSourceStatusChange([](client_side::data_sources::DataSourceStatus status) {
        if (status.State() ==
        client_side::data_sources::DataSourceStatus::
        DataSourceState::kValid) {
          /* Flag data has been received from LaunchDarkly.*/
        }
      });
If you are working in C, there are a few more steps:
  1. Define a callback to receive the data source status change:
         void OnDataSourceStatusChanged(LDDataSourceStatus status, void* user_data) {
           printf("status: %d\n", LDDataSourceStatus_GetState(status));
         }
  1. Assign the callback by creating a listener connection:
         struct LDDataSourceStatusListener listener;
         LDDataSourceStatusListener_Init(listener);

         listener.StatusChanged = OnDataSourceStatusChanged;

         /* You may optionally assign the UserData pointer, which will be passed into StatusChanged. */
         /* listener.UserData = &some_struct; */

         LDListenerConnection connection =
                 LDClientSDK_DataSourceStatus_OnStatusChange(sdk, listener);

         /* You can disconnect the listener later */
         LDListenerConnection_Disconnect(connection);
  1. Ensure the connection is freed when you are done with it:
         LDListenerConnection_Free(connection);
Finally, if you are working in C but are still using the older v2.x SDK, the data source status interface is not available. To wait indefinitely, use a callback:
      void initCallback(LDStatus status)
      {
          if (status == LDStatusInitialized) {
              printf("Completed LaunchDarkly client initialization");
          }
      }

      LDSetClientStatusCallback(initCallback);
To learn more, read DataSourceStatus.

Electron

By default, the client requests feature flag values only once per user. This happens once at startup time, and then each time you call identify(). You can also use a persistent connection to receive flag updates whenever they occur.Enable this behavior by setting streaming to true in the client options or calling client.setStreaming(true). LaunchDarkly pushes new values to the SDK, which updates the current feature flag state in the background, ensuring that variation() always returns the latest values.If you want to be notified when a flag has changed, you can use an event listener for a specific flag.Here’s how:
      client.on('change:example-flag-key', (newValue, oldValue) => {
        console.log('The flag was ' + oldValue + ' and now it is ' + newValue);
      });
Alternatively, you can listen for all feature flag changes.Here’s how:
      client.on('change', (allFlagChanges) => {
        Object.keys(allFlagChanges).forEach((key) => {
          console.log('Flag ' + key + ' is now ' + allFlagChanges[key]);
        });
      });
Subscribing to change events automatically turns on streaming mode as well, unless you have explicitly set streaming to false.

Flutter

The Flutter SDK exposes some of its internal status through APIs to let your application monitor it. This allows the application to determine how recently the internal flag cache has been updated with the most recent values, as well as diagnose potential reasons for the flag cache to be out of date.The SDK stores a timestamp of the most recent successful and failed connections to LaunchDarkly, as well as information related to the most recent failed connection. The dataSourceStatus returns a structure that lets you retrieve these fields.
      // get the current status
      final status = client.dataSourceStatus;

      // listen for changes
      final sub = client.dataSourceStatusChanges.listen((status){
        // act on status
      });
To learn more about the connection status fields, read DataSourceStatus.

iOS

This feature is available in the iOS SDK’s versions 4.2.0 and later.
The iOS SDK exposes some of its internal status through the Connection Status API to let your application monitor it. This allows the application to determine how recently the internal flag cache has been updated with the most recent values, as well as diagnosing potential reasons for the flag cache to be out of date.The SDK has four connectivity states dependent on its configuration, application foreground state, network connectivity, and calls explicitly setting the client offline or online.This table describes the states:| Connection Mode
Description
| --- | | streaming | The SDK has an active streaming connection. | | polling | The SDK has an active polling connection. | | offline | The SDK is set offline or has no network connection. | | establishingStreamingConnection | The SDK is attempting to connect to LaunchDarkly by streaming. |The SDK also stores a timestamp of the most recent successful and failed connections to LaunchDarkly, as well as information related to the most recent failed connection. lastKnownFlagValidity is nil if either no connection has ever been made successfully or if the SDK has an active streaming connection. It has a value if it is in polling mode and at least one poll has completed successfully, or if it is in streaming mode whenever the streaming connection closes. The LDClient.shared method getConnectionInformation() returns a structure that lets you retrieve these fields.The ConnectionInformation class can return four different values for lastFailureReason.This table describes the values:| lastFailureReason value
Description
| --- | | none | This returns when no error has been recorded. | | unknownError | This returns when there is an internal error in the stream request. | | unauthorized | This returns when an incorrect mobile key is provided. | | httpError | This returns when an error with an HTTP error code is present. |You can listen to changes in ConnectionInformation.ConnectionMode in a similar manner to flag observers.Here is an example of the API:
      // Get current connection information
      let connectionInformation = LDClient.get()!.getConnectionInformation()
      // Setting a connection mode update observer
      LDClient.get()!.observeCurrentConnectionMode(owner: self) { [weak self] connectionMode in
          // do something after ConnectionMode was updated.
      }

Java

Script
The SDK uses an emitter pattern for errors. You can subscribe to change, error, and dataSourceStatus events. When you subscribe to dataSourceStatus events, the state returned may be one of Initializing, Valid, Interrupted, SetOffline, Closed.Here’s how:
      client.on('dataSourceStatus', (context, error) => {
        // handle error

        // error.state may be one of:
        // Initializing, Valid, Interrupted, SetOffline, Closed
      });
To learn more, read DataSourceStatus.

React Native

Starting with version 10 of the React Native SDK, the SDK uses an emitter pattern for errors. You can subscribe to error and change events.Here’s how:
      client.on('error', (context: LDContext, error: Error) => {
        // handle error
      });
To learn more, read on and off.

Roku

You can use Roku’s observeField method on your node to respond to changes in status.Here’s how:

      ' replace "onStatusChange" with the name of your handler functions
      launchDarklyNode.observeField("status", "onStatusChange")

Server-side SDKs

The following server-side SDKs provide two kinds of SDK status monitoring:
  • Data source status
  • Data store status
Data source status is the status of the SDK’s communication with LaunchDarkly to get feature flag data. If the streaming connection to LaunchDarkly is interrupted, or, in polling mode, if a polling request fails, the SDK might not be able to receive flag updates. The data source status will indicate this, providing an overall state such as “valid” or “interrupted” and information about the last error that occurred, if any. Data store status is the status of a database, such as Redis or DynamoDB, if the SDK has been configured to use one. If the SDK tries to read from or write to a database and encounters an error, the data store status will indicate this. This feature is available in the following server-side SDKs:

.NET (server-side)

This feature is available in the .NET SDK’s versions 6.0.0 and later.
To check the data source status:
      var dataSourceStatus = client.DataSourceStatusProvider.Status;
Alternatively, you can register an event handler that will receive a new status value whenever the status changes.Here is an example:
      client.DataSourceStatusProvider.StatusChanged +=
          (sender, status) => {
              Console.WriteLine("new status is: {0}", status);
          };

C++ (server-side)

The C++ (server-side) SDK exposes some of its internal status to let your application monitor it.The SDK has several data source states dependent on its configuration, network connectivity, and calls explicitly setting the client offline or online.This table describes the states:| Data source state
Description
| --- | | kInitializing| The initial state of the data source when the SDK is being initialized. | | kValid| The data source is currently operational and has not had any problems since the last time it received data. | | kInterrupted| The data source encountered an error that it will attempt to recover from. | | kSetOffline| The application has told the SDK to stay offline. | | kShutdown| The data source has been permanently shut down. This could be because it encountered an unrecoverable error, or because the SDK client was explicitly shut down. |The SDK stores a timestamp of when the data source state most recently changed. It also stores information about the last error that the data source encountered, if any.This table describes the possible errors:| LastError value
Description
| --- | | kUnknown| An unexpected error, such as an uncaught exception. | | kNetworkError| An I/O error, such as a dropped connection. | | kErrorResponse| The LaunchDarkly service returned an HTTP response with an error status. | | kInvalidData| The SDK received malformed data from the LaunchDarkly service. | | kStoreError| The data source itself is working, but when it tried to put an update into the data store, the data store failed. The SDK may not have the latest data. |Here’s how to monitor the data source state:
      client.DataSourceStatus().OnDataSourceStatusChange([](server_side::data_sources::DataSourceStatus status) {
        if (status.State() ==
        server_side::data_sources::DataSourceStatus::
        DataSourceState::kValid) {
          /* Flag data has been received from LaunchDarkly.*/
        }
      });
If you are working in C, there are a few more steps:
  1. Define a callback to receive the data source status change:
         void OnDataSourceStatusChanged(LDServerDataSourceStatus status, void* user_data) {
           printf("status: %d\n", LDServerDataSourceStatus_GetState(status));
         }
  1. Assign the callback by creating a listener connection:
         struct LDServerDataSourceStatusListener listener;
         LDServerDataSourceStatusListener_Init(&listener);

         listener.StatusChanged = OnDataSourceStatusChanged;

         /* You may optionally assign the UserData pointer, which will be passed into
         * StatusChanged. */

         /* listener.UserData = &some_struct; */

         LDListenerConnection connection = LDServerSDK_DataSourceStatus_OnStatusChange(client, listener);

         /* You can disconnect the listener later */
         LDListenerConnection_Disconnect(connection);
  1. Ensure the connection is freed when you are done with it:
         LDListenerConnection_Free(connection);
To learn more, read DataSourceStatus() in Client.

Go

To check the data source status:
      dataSourceStatus := client.GetDataSourceStatusProvider().GetStatus()
Alternatively, you can monitor a channel that provides a new status value whenever the status changes:
      dataStoreStatusChannel := client.GetDataStoreStatusProvider().AddStatusListener()
      go func() {
          for status := range dataStoreStatusChannel {
              fmt.Println("new status is: ", status)
          }
      }()
To learn more, read GetDataSourceStatusProvider and GetDataStoreStatusProvider.

Java

To check the data source status:
      DataSourceStatusProvider.Status dataSourceStatus =
        client.getDataSourceStatusProvider().getStatus();
Alternatively, you can register an event listener that receives a new status value whenever the status changes:
      client.getDataSourceStatusProvider().addStatusListener(
        status -> {
          System.out.println("new status is: " + status);
        }
      );
To learn more, read DataSourceStatusProvider and DataStoreStatusProvider.

Python

To check the data source status:
      status = ldclient.get().data_source_status_provider.status
Alternatively, you can register an event listener that receives a new status value whenever the status changes:
      listener = ldclient.get().data_source_status_provider.add_listener(source_status_listener)
To learn more, read DataSourceStatusProvider and DataStoreStatusProvider.If you are working with forking processes, any configuration that you provide to the SDK must survive the forking process independently. We recommend that you add any listeners after a postfork() call, unless you are certain they can survive the forking process. To learn more, read Initialize the client and ldclient.postfork.

Ruby

To check the data source status:
      status = client.data_source_status_provider.status
Alternatively, you can register an event listener that receives a new status value whenever the status changes:
      # listener#update will be called when the status is changed
      client.data_source_status_provider.add_listener(listener);
To learn more, read DataSource::StatusProvider and DataStore::StatusProvider.If you are working with forking processes, any configuration that you provide to the SDK must survive the forking process independently. We recommend that you add any listeners after a postfork() call, unless you are certain they can survive the forking process. To learn more, read Initialize the client and postfork.